/* Problem URL: https://codeforces.com/problemset/problem/1968/G1 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

struct hash_string {
    static vl p;
    static ll m;
    static ll b;
    vl hash;

    hash_string(string &a) {
        while (p.size() <= a.size()) {
            p.push_back(((__int128)p.back() * b) % m);
        }

        hash.resize(a.size() + 1);
        rep(i, a.size()) {
            hash[i + 1] = ((__int128)hash[i] * b + a[i]) % m;
        }
    }

    ll gethash(int l, int r) {
        return ((hash[r + 1] - (__int128)hash[l] * p[r - l + 1]) % m + m) % m;
    }
};

vl hash_string::p = {1};
ll hash_string:: m = (1LL << 61) - 1;
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());
ll hash_string:: b = uniform_int_distribution<>()(rng);

void solve()
{
    int n, l, r;
    cin >> n >> l >> r;
    string a;
    cin >> a;

    hash_string ah(a);

    int low = 1;
    int high = n;
    int ans = 0;
    while (low <= high) {
        int mid = (low + high) >> 1;

        int c = 1;
        for (int i = mid; i + mid - 1 < n; i++) {
            if (ah.gethash(0, mid - 1) == ah.gethash(i, i + mid - 1)) {
                c++;
                i += mid - 1;
            }
        }

        if (c >= l) {
            ans = mid;
            low = mid + 1;
            continue;
        }

        high = mid - 1;
    }

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
